uk.ac.starlink.parquet

## Class StarParquetWriter.StarBuilder

- java.lang.Object
- - <any>
  - - uk.ac.starlink.parquet.StarParquetWriter.StarBuilder

- Enclosing class:
    StarParquetWriter

      public static class StarParquetWriter.StarBuilder
      extends <any>

  Used to configure and produce a ParquetWriter for StarTable output.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `StarBuilder(StarTable table, OutputFile ofile)` Constructor based on a parquet OutputFile.
    `StarBuilder(StarTable table, Path path)` Constructor based on a hadoop Path.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `StarTable` | `getTable()` Returns the table that this writer will write.
    `<any>` | `getWriteSupport(Configuration config)`
    `StarParquetWriter.StarBuilder` | `self()`
    `StarParquetWriter.StarBuilder` | `withGroupArray(boolean groupArray)` Configures array-valued column writing style.
    `StarParquetWriter.StarBuilder` | `withKeyValueItems(java.util.Map<java.lang.String,java.lang.String> kvItems)` Configures additional content for the key-value metadata in the parquet footer.
    `StarParquetWriter.StarBuilder` | `withVOTableMetadata(VOTableVersion version)` Configures output of metadata in VOTable format.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### StarBuilder

          public StarBuilder(StarTable table,
                             Path path)
                      throws java.io.IOException

      Constructor based on a hadoop Path.
      Parameters:
        `table` - table to write
        `path` - destination path
      Throws:
        `java.io.IOException`

    - #### StarBuilder

          public StarBuilder(StarTable table,
                             OutputFile ofile)

      Constructor based on a parquet OutputFile.
      Parameters:
        `table` - table to write
        `ofile` - destination file

  - ### Method Detail

    - #### getTable

          public StarTable getTable()

      Returns the table that this writer will write.
      Returns:
        table

    - #### withGroupArray

          public StarParquetWriter.StarBuilder withGroupArray(boolean groupArray)

      Configures array-valued column writing style.
      Parameters:
        `groupArray` - true for group-style arrays, false for repeated primitives

    - #### withVOTableMetadata

          public StarParquetWriter.StarBuilder withVOTableMetadata(VOTableVersion version)

      Configures output of metadata in VOTable format. If a non-null value is supplied, metadata will be written into the output file key-value extra metadata list under the key `ParquetStarTable.VOTMETA_KEY`.
      Parameters:
        `version` - VOTable version for dummy metadata table, or null if not required

    - #### withKeyValueItems

          public StarParquetWriter.StarBuilder withKeyValueItems(java.util.Map<java.lang.String,java.lang.String> kvItems)

      Configures additional content for the key-value metadata in the parquet footer. Any items supplied here will override values supplied in other ways. An entry with a null value will have the effect of removing the corresponding key.
      Parameters:
        `kvItems` - additional key-value metadata for parquet footer

    - #### self

          public StarParquetWriter.StarBuilder self()

    - #### getWriteSupport

          public <any> getWriteSupport(Configuration config)